import { _Callback, AsyncCallbackFn, CallbackFn, Context, PositionType } from "./types";
import { WalkNode } from "./node";
export declare function _matchCallbacks<T extends CallbackFn>(node: WalkNode, position: PositionType, ctx: Context<T>): _Callback<T>[];
export declare class _CallbackStacker<T extends CallbackFn, Rt> {
    private executor;
    constructor(executor: (callbacks: _Callback<T>[], node: WalkNode) => Rt);
    static ForSync(): _CallbackStacker<CallbackFn, void>;
    static ForAsync(parallel: boolean): _CallbackStacker<AsyncCallbackFn, void | Promise<void>>;
    private lookup;
    push(key: number, node: WalkNode, callbacks: _Callback<T>[]): void;
    executeOne(node: WalkNode, callbacks: _Callback<T>[]): Rt;
    execute(nodeId: number): Generator<Rt>;
}
